/*
  Dragon Slayer like RPG
  By: Nukem Enterprises
  
  Started Date: 5-18-03
  Current Date: 5-26-03
  Current # of Lines: 775
  
  TO DO LIST:
  -----------
  1) Dialog from who and dialog number needs to be programmed, or atleast a basic engine
     must be set up. Battle system needs to get a better GUI (maybe)...
  
  2) Need to set up world map/town map differences... Atleast start the idea between them..
     Ex: villagers only in villages and badguys are only randomized in world map. 
  
  3) Possible weapons/armor system set up???
     if so, a system of currency must be set up.. badguys must drop gold! (random preferred)
  
  4) Final enemy names needed, also final enemy stats are needed...
  
  5) Character stats must become balanced, Kazik needs magic, and Rune as of now is WAY
     too powerful. Kazik also needs to have a magic bar (MP) so that he does not have infinite
     magic to use.
  
  6) NEED FINAL GAME NAME! "RPG" WILL-NOT-DO!
  
  Err.. there's more, but that's a start.
*/

#include <conio.h>
#include <conio.c> //for locating and text colors....
#include <stdio.h>
#include <string>
#include <iostream.h>
#include <time.h>
#define NUMBER_OF_MEMBERS 4
#define AMOUNT_OF_VILLAGERS 5

using namespace std;

struct stats //character stats structure
{            //name is declared main function
  int dfp;
  int currentHP;
  int maxHP;
  int atk;
  int lvl;
  int status;
  int exp;
  int baseExp;
  int kills;
  int memberNumber;
  string memberName;
  string memberClass;
};

struct monster //monster stats stucture
{
  int monDfp;
  int monHP;
  int monAtk;
  int monExp;
  string monName;
};

struct NPC //for villagers
{
  int vXpos;
  int vYpos;
  int vDialogNumber;
  string vName;
};

//ascii scan code constants and global definitions....
const char up = 72;
const char down = 80;
const char leftArw = 75;
const char rightArw = 77;
const char enterBtn = 13;
const char spaceBar = 32;
int talkingWith = 1;
bool allDead = false;
NPC villager[AMOUNT_OF_VILLAGERS];
stats member[NUMBER_OF_MEMBERS];


void drawCharacterAndMask(int x, int y); //function prototypes
string getNameOrClass(int getWhich, int i);
int getStats(int statType, int memberNumber);
void viewStats();
void showDialog(int dialogNumber, int fromWho);
bool checkIfNPC(int xPos, int yPos);
void battle();
void initializeStats();


int main(int argc, char **argv)
{
  char input = kbhit(); //definitions....
  int xPos = 10, yPos = 10, i, randomBattle, amountOfVillagers = 5;
  bool personThere;

  srand(time(NULL)); //initialize randomization... 
  
  for (i = 0; i < amountOfVillagers; i++)
  {
    villager[i].vXpos = rand() % 79;
    villager[i].vYpos = rand() % 24;
    villager[i].vDialogNumber = 1;
    villager[i].vName = "Villager";
  }
  
  initializeStats(); //errr, yeah... Just just what it says.

  clrscr();
  gotoxy(xPos, yPos); //initial character draw
  printf("%c", 2); //ascii character #2 = happy face
  fflush(stdout);
  
  while (input != 27 && input != 113) //while not esc and not 'q'
  {
    randomBattle = rand() % 101; // random number
    
    /*Debug Stuff Start: */
    for (i = 0; i < amountOfVillagers; i++)
    {
      gotoxy(villager[i].vXpos, villager[i].vYpos); //villager draw
      printf("%c", 1);
      fflush(stdout);
    }
    
    gotoxy(1, 1); //display (x,y) position
    printf("Xpos: %d\nYpos: %d\n", xPos, yPos);
    
    gotoxy(1, 3); //display if NPC detect has worked...
    if (personThere == true)
      printf("personThere = true \n");
    else
      printf("personThere = false\n");
    /* Debug Stuff End */
    
    if (allDead == true) //temp simple gameover screen... 
    {
      gotoxy(40, 15);
      printf("All members of your party has died...\n");
      gotoxy(45, 16);
      printf("GAME OVER!\n");
      getch();
      break; // out of game loop...
    }
    input = getch();
    switch (input)
    { 
      case up:
        yPos--;
        drawCharacterAndMask(xPos, yPos);
        personThere = checkIfNPC(xPos, yPos);
        break;
      case down:
        yPos++;
        drawCharacterAndMask(xPos, yPos);
        personThere = checkIfNPC(xPos, yPos);
        break;
      case leftArw:
        xPos--;
        drawCharacterAndMask(xPos, yPos);
        personThere = checkIfNPC(xPos, yPos);
        break;
      case rightArw:
        xPos++;
        drawCharacterAndMask(xPos, yPos);
        personThere = checkIfNPC(xPos, yPos);
        break;
      case spaceBar:
        if (personThere == true)
          showDialog(villager[1].vDialogNumber, talkingWith);
        break;
      case enterBtn: //view stats
        clrscr();
        viewStats();
        getch();
        clrscr();
        break;
    }
        
    if (randomBattle == 10) //this is at the end to avoid blank screen...
    { 
      clrscr(); 
      battle();
    }
    
  }
    
  clrscr();
 
  return 0;
}

void battle()
{
  int monsterType = rand() % 2, damageRecieved, damageDelt, i, runAway, expGained;
  int attackWho;
  monster monster; //using the monster structure.
  char choice;
  bool battle = true;
  
  switch (monsterType) //using temporary names!!!
  {
    case 0:
      monster.monName = "Wounded Soldier";
      monster.monHP = 5;
      monster.monDfp = 2;
      monster.monAtk = 3;
      monster.monExp = 2;
      break;
    
    case 1:
      monster.monName = "Drinead Soldier";
      monster.monHP = 10;
      monster.monDfp = 3;
      monster.monAtk = 4;
      monster.monExp = 4;
      break;
    
    default:
      printf("OUT OF RANGE MONSTER SELECTED!!!!\n");
      getch();
      break;
    //finish case statements
  }
  
  while (battle == true)
  {
    for (i = 0; i < NUMBER_OF_MEMBERS; i++)
    {
      if (member[i].status != 0) //if not dead basically...
      {
        clrscr();
        cout<< "HP: " << member[i].currentHP << "/" << member[i].maxHP << endl;
        cout<< monster.monName << "'s HP: " << monster.monHP << endl; 
        cout<< member[i].memberName << "'s turn!" << endl << endl;
        cout<< "(A)ttack" << endl << "(R)un" << endl << endl;
        choice = getch();
      
        if (choice == 'a' || choice == 'A') //if attacks...
        {
          damageDelt = member[i].atk - monster.monDfp; //calculates the damage delt
          if (damageDelt < 0) // makes the damage zero if it's negative...
            damageDelt = 0;
          monster.monHP -= damageDelt; // adjusts monsters HP accordingly.
          cout<< member[i].memberName << " attacks!" << endl;
          cout<< monster.monName << " recieves " << damageDelt << " damage!" << endl;
          
          if (monster.monHP <= 0) // if the party wins the battle...
          {
            expGained = monster.monExp;
            cout<< endl << monster.monName << " expires! " << endl << endl;
            switch (i) //gets and displays experianced gained for all party members...
            {          //no exp for the dead, that's why there's all those "if" statements...
              case 0:
                cout<< member[0].memberName << " recieves " << (expGained * 2) << " experiance!" << endl;                
                if (member[1].status != 0)
                  cout<< member[1].memberName << " recieves " << expGained << " experiance!" << endl;                
                if (member[2].status != 0)
                  cout<< member[2].memberName << " recieves " << expGained << " experiance!" << endl;                
                if (member[3].status != 0)
                  cout<< member[3].memberName << " recieves " << expGained << " experiance!" << endl;                
                
                member[0].kills++;
                member[0].exp -= (expGained * 2);
                if (member[1].status != 0)
                  member[1].exp -= expGained;
                if (member[2].status != 0)
                  member[2].exp -= expGained;
                if (member[3].status != 0)
                  member[3].exp -= expGained;
                
                break;
              case 1:
                cout<< member[1].memberName << " recieves " << (expGained * 2) << " experiance!" << endl;                
                if (member[0].status != 0)
                  cout<< member[0].memberName << " recieves " << expGained << " experiance!" << endl;                
                if (member[2].status != 0)
                  cout<< member[2].memberName << " recieves " << expGained << " experiance!" << endl;                
                if (member[3].status != 0)
                  cout<< member[3].memberName << " recieves " << expGained << " experiance!" << endl;                
                
                member[1].kills++;
                member[1].exp -= (expGained * 2);
                if (member[0].status != 0)
                  member[0].exp -= expGained;
                if (member[2].status != 0)
                  member[2].exp -= expGained;
                if (member[3].status != 0)
                  member[3].exp -= expGained;
                
                break;
              case 2:
                cout<< member[2].memberName << " recieves " << (expGained * 2) << " experiance!" << endl;                
                if (member[0].status != 0)
                  cout<< member[0].memberName << " recieves " << expGained << " experiance!" << endl;                
                if (member[1].status != 0)
                  cout<< member[1].memberName << " recieves " << expGained << " experiance!" << endl;                
                if (member[3].status != 0)
                  cout<< member[3].memberName << " recieves " << expGained << " experiance!" << endl;                
                
                member[2].kills++;
                member[2].exp -= (expGained * 2);
                if (member[0].status != 0)
                  member[0].exp -= expGained;
                if (member[1].status != 0)
                  member[1].exp -= expGained;
                if (member[3].status != 0)
                  member[3].exp -= expGained;
                
                break;
              case 3:
                cout<< member[3].memberName << " recieves " << (expGained * 2) << " experiance!" << endl;                
                if (member[0].status != 0)
                  cout<< member[0].memberName << " recieves " << expGained << " experiance!" << endl;                
                if (member[1].status != 0)
                  cout<< member[1].memberName << " recieves " << expGained << " experiance!" << endl;                
                if (member[2].status != 0)
                  cout<< member[2].memberName << " recieves " << expGained << " experiance!" << endl;                
                
                member[3].kills++;
                member[3].exp -= (expGained * 2);
                if (member[0].status != 0)
                  member[0].exp -= expGained;
                if (member[1].status != 0)
                  member[1].exp -= expGained;
                if (member[2].status != 0)
                  member[2].exp -= expGained;
                
                break;
            } //switch end
            
            for (int z = 0; z < NUMBER_OF_MEMBERS; z++)
            {
              if (member[z].exp <= 0)
              {
                getch();
                member[z].lvl++;
                member[z].baseExp += (member[z].lvl * 3);
                member[z].exp = member[z].baseExp;
                
                clrscr();
                cout<< endl << member[z].memberName << " leveled up!" << endl;
                cout<< member[z].memberName << " is now level " << member[z].lvl << "!" << endl << endl;
                
                if (member[z].memberNumber == 0) //main char...
                {
                  member[z].atk += 1;
                  member[z].dfp += 1;
                  member[z].maxHP += 2;
                  member[z].currentHP = member[z].maxHP;
                  cout<< "ATP + 1 " << endl << "DFP + 1 " << endl << "MAX HP + 2" << endl;
                  cout<< "HP Completly restored!" << endl;
                }
                else if (member[z].memberNumber == 1) //shyde...
                {
                  member[z].atk += 2;
                  member[z].dfp += 1;
                  member[z].maxHP += 1;
                  member[z].currentHP = member[z].maxHP;
                  cout<< "ATP +1 " << endl << "DFP + 1 " << endl << "MAX HP + 2" << endl;
                  cout<< "HP Completly restored!" << endl;
                }
                
                else if (member[z].memberNumber == 2) //rune...
                {                  
                  member[z].atk += 1;
                  member[z].dfp += 2;
                  member[z].maxHP += 1;
                  member[z].currentHP = member[z].maxHP;
                  cout<< "ATP +1 " << endl << "DFP + 1 " << endl << "MAX HP + 2" << endl;
                  cout<< "HP Completly restored!" << endl;
                }
                
                else if (member[z].memberNumber == 3) //kazik...
                {
                  member[z].atk += 1;
                  member[z].dfp += 1;
                  member[z].maxHP += 1;
                  member[z].currentHP = member[z].maxHP;
                  cout<< "ATP +1 " << endl << "DFP + 1 " << endl << "MAX HP + 1" << endl;
                  cout<< "HP Completly restored!" << endl;
                } 
                getch();  
              } //if end.
            } //for end           
                
            battle = false;
            break; //from for loop
          }

          getch();
        }
      
        else if (choice == 'r' || choice == 'R')
        {
          cout<< member[i].memberName << " attempts to run....";
          runAway = rand() % 10;

          if (runAway == 3)
          {  
            cout<< " and manages to flee! " << endl << "Battle Ended";
            battle = false;
            break; //out of for loop
            getch();
          }
          else
          {
            damageRecieved = monster.monAtk - member[i].dfp;
            if (damageRecieved < 0)
              damageRecieved = 0;
            member[i].currentHP -= damageRecieved;
            cout<< " but can't!" << endl; 
            cout<< member[i].memberName << " recieves " << damageRecieved << " damage!" << endl;
            if (member[i].currentHP <= 0)
            {
              member[i].currentHP = 0;
              member[i].status = 0; //makes 'em dead >:P
              cout<< member[i].memberName << " expires... " << endl;
            }
            getch();
          }
        } //else if end
      
        else // invalid entry check..
          i--;
      } //alive check if end...
      
      else if (member[i].status == 0) //not just "else" b/c they can be "2" AKA poisoned!!!
      {
        clrscr();
        cout<< "HP: " << member[i].currentHP << "/" << member[i].maxHP << endl;
        cout<< monster.monName << "'s HP: " << monster.monHP << endl; 
        cout<< member[i].memberName << "'s turn!" << endl << endl;
        cout<< member[i].memberName << " is dead and cannot move... " << endl;
        getch();
      }  
    } //for end      
    
    attackWho = rand() % 4;
    
    if (member[attackWho].status != 0 && battle == true) //random member selected to be attacked.
    {
      damageRecieved = monster.monAtk - member[attackWho].dfp;
      if (damageRecieved < 0) //so it's not negative...
        damageRecieved = 0;
      
      member[attackWho].currentHP -= damageRecieved;
    
      cout<< endl << monster.monName << " attacks!" << endl;
      cout<< member[attackWho].memberName << " suffers " << damageRecieved << " damage!" << endl << endl;
    
      if (member[attackWho].currentHP <= 0)
      {
        member[attackWho].currentHP = 0;
        member[attackWho].status = 0; //makes 'em dead >:P
        cout<< member[attackWho].memberName << " expires... " << endl;
      }
    }
    
    else if (battle == true)
    {
      cout<< endl << monster.monName << " attacks! " << endl;
      cout<< "...but " << member[attackWho].memberName << " is already dead and can recieve no more damage." << endl;
    }
    
    getch();
                            
    if (member[0].status == 0 && member[1].status == 0 && member[2].status == 0 && member[3].status == 0)
    { //wew that's a long line! :D
      allDead = true;
      battle = false;
    }
  }// while end
  
  getch();
  clrscr();
}

void initializeStats() //uses global variables, sets stats up.
{
  int i;
  for (i = 0; i < NUMBER_OF_MEMBERS; i++) 
  {
    member[i].memberName = getNameOrClass(1, i);
    member[i].memberClass = getNameOrClass(2, i);
    member[i].maxHP = getStats(1, i);
    member[i].atk = getStats(2, i);
    member[i].dfp = getStats(3, i);
    member[i].currentHP = member[i].maxHP;
    member[i].lvl = 1;
    member[i].status = 1; //alive and fine.
    member[i].exp = 25;
    member[i].baseExp = member[i].exp;
    member[i].kills = 0;
    member[i].memberNumber = i;
  }

}

bool checkIfNPC(int playerX, int playerY)//checks for NPC
{
  bool personThere = false;
  
  for (int i = 0; i < AMOUNT_OF_VILLAGERS; i++)
  {
    if ((playerX - 1 == villager[i].vXpos) && (playerY == villager[i].vYpos))
      personThere = true;
    else if ((playerX + 1 == villager[i].vXpos) && (playerY  == villager[i].vYpos))
      personThere = true;
    else if ((playerX == villager[i].vXpos) && (playerY + 1 == villager[i].vYpos))
      personThere = true;
    else if ((playerX == villager[i].vXpos) && (playerY - 1 == villager[i].vYpos))
      personThere = true;
    else if ((playerX == villager[i].vXpos) && (playerY == villager[i].vYpos))
      personThere = true; 
  }
  
  return personThere;
}

void showDialog(int dialogNumber, int fromWho)
{
  
  if (fromWho == 1)
  {
    switch (dialogNumber)
    {
      case 1:
        gotoxy(1, 5);
        textcolor(7);
        
        cout<< villager[1].vName << ": What the hell do you want? " << endl;
        
        getch();
        break;
    } //switch end
  } //if end
  
  clrscr();
}

void viewStats()
{

  cout<< "  NAME: " << member[0].memberName << " (lv." << member[0].lvl << ")" << endl;
  cout<< " CLASS: " << member[0].memberClass << endl;
  printf("    HP: %d / %d\n", member[0].currentHP, member[0].maxHP);
  printf("   ATK: %d\n", member[0].atk);
  printf("   DEF: %d\n", member[0].dfp);
  printf("   EXP: %d\n", member[0].exp);
  printf(" Kills: %d\n", member[0].kills);
  if (member[0].status == 1)
    printf("Status: Alive\n\n");
  else if (member[0].status == 0)
    printf("Status: Dead\n\n");

  gotoxy(22, 1);
  cout<< " NAME: " << member[1].memberName << " (lv." << member[1].lvl << ")" << endl;
  gotoxy(22, 2);
  cout<< "CLASS: " << member[1].memberClass << endl;
  gotoxy(22, 3);
  printf("   HP: %d / %d\n", member[1].currentHP, member[1].maxHP);
  gotoxy(22, 4);
  printf("  ATK: %d\n", member[1].atk);
  gotoxy(22, 5);
  printf("  DEF: %d\n", member[1].dfp);
  gotoxy(22, 6);
  printf("  EXP: %d\n", member[1].exp);
  gotoxy(22, 7);
  printf("Kills: %d\n\n", member[1].kills);
  if (member[1].status == 1)
  {  
    gotoxy(21, 8);
    printf("Status: Alive\n\n");
  }
  else if (member[1].status == 0)
  {
    gotoxy(21, 8); 
    printf("Status: Dead\n\n");
  }
  
  gotoxy(41, 1);
  cout<< " NAME: " << member[2].memberName << " (lv." << member[2].lvl << ")" << endl;
  gotoxy(41, 2);
  cout<< "CLASS: " << member[2].memberClass << endl;
  gotoxy(41, 3);
  printf("   HP: %d / %d\n", member[2].currentHP, member[2].maxHP);
  gotoxy(41, 4);
  printf("  ATK: %d\n", member[2].atk);
  gotoxy(41, 5);
  printf("  DEF: %d\n", member[2].dfp);
  gotoxy(41, 6);
  printf("  EXP: %d\n", member[2].exp);
  gotoxy(41, 7);
  printf("Kills: %d\n\n", member[2].kills);
  if (member[2].status == 1)
  {  
    gotoxy(40, 8);
    printf("Status: Alive\n\n");
  }
  else if (member[2].status == 0)
  {
    gotoxy(40, 8); 
    printf("Status: Dead\n\n");
  }
  
  gotoxy(60, 1);
  cout<< " NAME: " << member[3].memberName << " (lv." << member[3].lvl << ")" << endl;
  gotoxy(60, 2);
  cout<< "CLASS: " << member[3].memberClass << endl;
  gotoxy(60, 3);
  printf("   HP: %d / %d\n", member[3].currentHP, member[3].maxHP);
  gotoxy(60, 4);
  printf("  ATK: %d\n", member[3].atk);
  gotoxy(60, 5);
  printf("  DEF: %d\n", member[3].dfp);
  gotoxy(60, 6);
  printf("  EXP: %d\n", member[3].exp);
  gotoxy(60, 7);
  printf("Kills: %d\n\n", member[3].kills);
  if (member[3].status == 1)
  {  
    gotoxy(59, 8);
    printf("Status: Alive\n\n");
  }
  else if (member[3].status == 0)
  {
    gotoxy(59, 8); 
    printf("Status: Dead\n\n");
  }

  gotoxy(5, 10);
  printf("Press any key to return to game...\n");
}  

void drawCharacterAndMask(int x, int y)
{  
  //this is a bit lengthy mask, perhaps there's a shorter way???
  gotoxy(x - 1, y);
  printf(" ");

  gotoxy(x + 1, y);
  printf(" ");

  gotoxy(x, y - 1);
  printf(" ");

  gotoxy(x, y + 1);
  printf(" ");
  
  gotoxy(x, y); //draw
  printf("%c", 2);
  fflush(stdout);
}

string getNameOrClass(int getWhich, int i)
{
  string charName, charClass;
  
  if (getWhich == 1)
  {
    switch (i)
    {
      case 0:
        gotoxy(1, 2);
        printf("[Note: Only one word]\n\n Help:\nENTER - View Stats\n'q' or Esc - Quit\nArrow keys move.\n");
        gotoxy(1, 1);
        printf("Enter main character's name: ");
        fflush(stdout);
        cin>> charName;
        break;
      case 1:
        charName = "Shyde";
        break;
      case 2:
        charName = "Rune";
        break;
      default:
        charName = "Kazik";
        break;
    }
    return charName;
  }
  
  if (getWhich == 2)
  {
    switch (i)
    {
      case 0:
        charClass = "Hero";
        break;
      case 1:
        charClass = "Archer";
        break;
      case 2:
        charClass = "Knight";
        break;
      default:
        charClass = "Mage";
        break;
    }
    return charClass;
  }
  
}

int getStats(int statType, int memberNumber)
{
  int maxHP, dfp, atk;
  
  if (statType == 1) //gets characters HP
  {
    switch (memberNumber)
    {
      case 0:
        maxHP = 5;
        break;
      case 1:
        maxHP = 6;
        break;
      case 2:
        maxHP = 2;
        break;
      case 3:
        maxHP = 10;
        break;
    } //switch end
    return maxHP;
  } //if end
  
  else if (statType == 2) //gets attack power
  {
    switch (memberNumber)
    {
      case 0:
        atk = 4;
        break;
      case 1:
        atk = 4;
        break;
      case 2: 
        atk = 3;
        break;
      case 3:
        atk = 2;
        break;
    } //switch end
    return atk;
  } //else if end
  
  else //gets defense power
  {
    switch (memberNumber)
    {
      case 0:
        dfp = 3;
        break;
      case 1:
        dfp = 2;
        break;
      case 2:
        dfp = 1;
        break;
      case 3:
        dfp = 3;
        break;
    } //switch end
    return dfp;
  } //else end
}

